<template>
  <view class="content">
	<top-title :titleValue="title" style="width: 100%;"></top-title>
    <div class="self-inf">
      <div class="img-name-box" v-if="isAuth">
        <image :src="userHeadImg" class="heade-img" mode="aspectFill"></image>
        <p class="nickname">{{ userNickName }}</p>
      </div>
      <view class="img-name-box" v-if="!isAuth">
		<image src="/static/auth-icon.png" class="heade-img" mode="aspectFill"></image>
        <button @click="goAuthPage()" class="auth-btn">授权登录</button>
      </view>
      <image class="bg-img" :src="swiperBackground" mode="aspectFill"></image>
      <image src="../../static/Intersect.svg" class="groove-img"></image>
    </div>
    <div class="options">
      <div
        v-for="(item, idx) in list"
        :key="idx"
        class="options-item"
        @click="goDetailFn(idx, item.url)"
      >
        <div class="img-box">
          <img :src="item.icoin" alt="" class="options-item-img" /><span></span>
        </div>
        <div
          class="options-item-name"
          :class="{ fontGrey: idx == list.length - 1 }"
        >
          {{ item.name }}
        </div>
      </div>
    </div>
	<foot-tabs :selectedIndex='1'></foot-tabs>
  </view>
</template>

<script>
import md5 from "@/common/md5.js";
import topTitle from '@/components/top-title/top-title.vue';
import footTabs from '@/components/foot-tabs/footTabs.vue';
export default {
	components: {
		'foot-tabs': footTabs,
		'top-title': topTitle
	},
  data() {
    return {
      title: "个人中心",
      isAuth: true,
      userHeadImg: "",
      userNickName: "",
      list: [
        { 
		 icoin: "/static/selfCenter/suggest.png",
		 name: "我的建议" ,
		 url: "/pages/appeal/myAppeal",
		 },
        { 
		  icoin: "/static/selfCenter/sign.png", 
		  name: "我的报名" ,
		  url: "/pages/selfCenter/my_activity",
		 },
        {
          icoin: "/static/selfCenter/collection.png",
          name: "我的收藏",
          url: "/pages/selfCenter/collection",
        },
        { icoin: "/static/selfCenter/back.png", name: "退出登录" },
      ],
      swiperBackground: "",
    };
  },
  onLoad() {
    this.getSwiperList();
  },
  onShow() {
    // 	 this.isAuth = getApp().globalData.isAuth;
    // if(this.isAuth){
    //  this.userHeadImg = getApp().globalData.user_headUrl;
    //  this.userNickName = getApp().globalData.user_name;
    // }
    this.getUserInfo();
  },
  methods: {
    goAuthPage() {
      uni.navigateTo({
        url: "../auth/index",
      });
    },
    goDetailFn(index, url) {
      let that = this;
	  if(!that.isAuth){
		  uni.showToast({
		    title: "您还没有登录授权",
		    duration: 2500,
		    icon: "none",
		  });
		  return;
	  }
      switch (index) {
        case 0: //我的建议
			uni.navigateTo({
			  url,
			}); 
          break;
        case 1: //我的报名
			uni.navigateTo({
			  url,
			}); 
          break;
        case 2: //我的收藏
			uni.navigateTo({
			  url,
			}); 
          break;
        case 3: //退出登录
            uni.showModal({
              title: "确定退出登录吗?",
              success(res) {
                if (res.confirm) {
                  that.loginOut();
                } else if (res.cancel) {
                  console.log("用户点击取消");
                }
              },
            });
          break;
      }
    },
    loginOut() {
      let md5Sign = md5(
        "method=" +
          "user" +
          "&timestamp=" +
          getApp().globalData.globalTimestamp +
          "&secret=" +
          getApp().globalData.secret
      );
      let url =
        getApp().globalData.shareUrl +
        "api/api.php" +
        "?method=user&action=logout&timestamp=" +
        getApp().globalData.globalTimestamp +
        "&sign=" +
        md5Sign;
      uni.request({
        url: url,
        method: "POST",
        header: {
          "content-type": "application/x-www-form-urlencoded",
        },
        data: {
          openId: getApp().globalData.open_id,
        },
        success: (res) => {
          if (res.data.code === 200) {
            this.isAuth = false;
            getApp().globalData.isAuth = false;
            getApp().globalData.user_headUrl = "";
            getApp().globalData.user_name = "";
            getApp().globalData.user_phone = "";
            uni.showToast({
              title: "退出登录成功",
              duration: 2500,
              icon: "none",
            });
          }
        },
        fail: () => {
          console.log("连接失败");
        },
      });
    },
    getUserInfo() {
      let md5Sign = md5(
        "method=" +
          "user" +
          "&timestamp=" +
          getApp().globalData.globalTimestamp +
          "&secret=" +
          getApp().globalData.secret
      );
      let url =
        getApp().globalData.shareUrl +
        "api/api.php" +
        "?method=user&action=info_by_openid&timestamp=" +
        getApp().globalData.globalTimestamp +
        "&sign=" +
        md5Sign;
      uni.request({
        url: url,
        method: "POST",
        header: {
          "content-type": "application/x-www-form-urlencoded",
        },
        data: {
          openId: getApp().globalData.open_id,
        },
        success: (res) => {
          if (res.data.code === 200) {
            if (res.data.data.nickname) {
              this.isAuth = true;
              this.userHeadImg = res.data.data.headimg;
              this.userNickName = res.data.data.nickname;
              getApp().globalData.user_phone = res.data.data.phone;
            } else {
              this.isAuth = false;
            }
          }
        },
        fail: () => {
          console.log("连接失败");
        },
      });
    },
    getSwiperList() {
      let md5Sign = md5(
        "method=" +
          "common" +
          "&timestamp=" +
          getApp().globalData.globalTimestamp +
          "&secret=" +
          getApp().globalData.secret
      );
      let url =
        getApp().globalData.shareUrl +
        "api/api.php" +
        "?method=common&source=main_pics&action=list&timestamp=" +
        getApp().globalData.globalTimestamp +
        "&sign=" +
        md5Sign;
      uni.request({
        url: url,
        method: "POST",
        header: {
          "content-type": "application/x-www-form-urlencoded",
        },
        data: {
          order_by: "weight desc",
          s_status: 1,
        },
        success: (res) => {
          if (res.data.code === 200) {
            this.swiperBackground =
              getApp().globalData.shareUrl + res.data.data.list[0].pic_path;
          }
        },
        fail: () => {
          console.log("连接失败");
        },
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.content {
  display: flex;
  flex-direction: column;

  .self-inf {
    position: relative;
    height: 440rpx;
    width: 100%;
    display: flex;
    margin-bottom: 80rpx;
    border-radius: 0rpx 0rpx 100% 100%;
    .img-name-box {
      height: 150rpx;
      margin-top: 110rpx;
      display: flex;
      align-items: center;
      .auth-btn {
		margin-left: 30rpx;
		margin-top: 20rpx;
        font-size: 28rpx;
        background-color: #02a7f0;
        color: #fff;
      }
      .heade-img {
        z-index: 1;
        width: 100rpx;
        height: 100rpx;
        border-radius: 50%;
        margin-left: 80rpx;
      }
    }

    .bg-img {
      z-index: -1;
      position: absolute;
      width: 100%;
      height: 100%;
      // border-radius: 0rpx 0rpx 70rpx 70rpx;
    }
    .groove-img {
      width: 100%;
      height: 100rpx;
      bottom: -22rpx;
      position: absolute;
    }
    .nickname {
      font-weight: 600;
      font-size: 28rpx;
      margin-left: 30rpx;
      margin-top: 20rpx;
      color: #ffffff;
      letter-spacing: 1rpx;
    }
  }
  .options {
    padding: 70rpx;
    z-index: 99;
    position: relative;
    top: -270rpx;
    .options-item {
      background-color: #fff;
      display: flex;
      box-shadow: 0px 4rpx 32rpx rgba(0, 0, 0, 0.1);
      border-radius: 32rpx;
      margin-top: 20px;
      height: 150rpx;
      align-items: center;
      .img-box {
        margin-left: 40rpx;
        .options-item-img {
          width: 56rpx;
          height: 56rpx;
        }
      }
      .options-item-name {
        margin-left: 40rpx;
        font-weight: 600;
        font-size: 30rpx;
        margin-bottom: 10rpx;
      }
    }
  }
}
.fontGrey {
  color: $uni-text-color-grey;
}
</style>